/*#################################################################
# Copyright (c) 1991 AT&T Bell Laboratories, All Rights Reserved
# Published in ``A C++ Primer''  by Stanley Lippman, Addison-Wesley
#################################################################*/

#ifndef TEXT_H
#define TEXT_H

#include <iostream.h>
#include <assert.h>
#include <string.h>

class Text {
    friend ostream& operator <<(ostream&,Text&);
    friend istream& operator >>(istream&,Text&);
    friend Text operator+(Text&,Text&);

public:
    Text(char*);
    Text(const Text&);
    Text();
    ~Text() { delete str; }

    Text operator()(int,int);
    Text operator()(int);
    Text operator()(int, char);
    Text operator()(char);
    Text fromLastCharToEnd(char);

    char& operator[](int);
    Text& operator=(const char*);
    Text& operator=(const Text&);
    Text& operator+=(const Text&);
    Text& operator+=(char);
    int operator==(const Text &s);

    int operator==(const char *s) { return (strcmp(str,s)==0); }
    int operator!() { return( len == 0 ); }

    int getLen() { return len; }
    int operator <(Text& s);
    int operator >(Text& s);
    void set(char*);
    char *get(void) {return str;}
private:
    int len;
    char *str;
};

#endif
