#ifndef ACTION_H
#define ACTION_H
#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include "Text.h"
#include "endovar.h"

#define BIRD_MAX_INHIBITOR_COUNT 10
#define BIRD_MAX_ENDOVAR_COUNT 10
#define BIRD_MAX_BLOCK_COUNT 10

class Endovar;

class Action {

public:

 ~Action();
  Action();

  inline Text &             getName(void) { return actionName; }
  inline double             getValue(void) { return value; }

  inline void               setName(const Text &name) { actionName = name; }
  inline void               setValue(double val) { value = val; }
  inline void               setFatigueGain(double g) { fatigueGain = g; }
  inline void               setFatigueLoss(double l) { fatigueLoss = l; }
  void                      setColor(GLubyte, GLubyte, GLubyte);
  
  void                      updateValue(void);
  void                      updateFatigue(void);

  void                      addInhibitor(Action *, double);
  void                      addEndovar(Endovar *, double);
  void                      addBlock(Relmech *, int);

  void                      executeAction(
  void                      drawValue(void);
  void                      drawFatigue(void);

private:

  // ---------------------- class variables --------------------------------

  Text                      actionName;
  double                    value;
  double                    fatigue, fatigueGain, fatigueLoss;

  int                       inhibitorCount;
  Action *                  inhibitors[BIRD_MAX_INHIBITOR_COUNT];
  double                    inhibitorGains[BIRD_MAX_INHIBITOR_COUNT];

  int                       endovarCount;
  Endovar *                 endovars[BIRD_MAX_ENDOVAR_COUNT];
  double                    endovarGains[BIRD_MAX_ENDOVAR_COUNT];

  int                       blockCount;
  Relmech *                 blocks[BIRD_MAX_BLOCK_COUNT];
  int                       flags[BIRD_MAX_BLOCK_COUNT];

  GLubyte                   red, green, blue;
  int                       startIndex;
  double                    valueHistory[100];
  double                    fatigueHistory[100];
};
	
#endif
