#ifndef ENDOVAR_H
#define ENDOVAR_H
#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include "action.h"
#include "relmech.h"
#include "Text.h"

class Action;

#define BIRD_MAX_ACTIONS 10
#define BIRD_MAX_RELMECHS 10

class Endovar {

public:

 ~Endovar();
  Endovar();

  inline Text &             getName(void) { return endovarName; }
  inline void               setName(const Text &name) { endovarName = name; }

  inline double             getValue(void) { return value; }
  void                      setValue(double val);
  void                      setMinValue(double val);
  void                      setColor(GLubyte, GLubyte, GLubyte);

  inline void               setAutoGain(double gain) { autoGain = gain; }
  
  void                      updateValue(void);
  void                      addAction(Action *, double);
  void                      addRelmech(Relmech *, double, double);

  void                      drawGL(void);

private:

  // ---------------------- class variables --------------------------------

  Text                      endovarName;

  double                    value, minValue;
  double                    autoGain;

  int                       actionCount;
  Action *                  actions[BIRD_MAX_ACTIONS];
  double                    gains[BIRD_MAX_ACTIONS];

  int                       relmechCount;
  Relmech *                 relmechs[BIRD_MAX_RELMECHS];
  double                    activeGains[BIRD_MAX_RELMECHS];
  double                    inactiveGains[BIRD_MAX_RELMECHS];

  GLubyte                   red, green, blue;
  int                       startIndex;
  double                    valueHistory[100];
};
	
#endif
